const app = getApp()
import { race_status } from '../../utils/dict';
Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: true, name: '小组赛管理', leftArrow: true, useBar: false },
        searchInfo: {},
        list: [],
        dialog: { title: '赛事管理', show: false, type: '1' },
        form: {},
        statusList: race_status,
    },
    back(e) {
        wx.navigateBack({ delta: 1 })
    },
    // 查询
    search: function (e) {
        const that = this;
        that.setData({ 'searchInfo.name': e.detail.value });
        that.watchLogin()
    },
    // 添加
    toCommon: function (e) {
        const that = this;
        const { route } = e.currentTarget.dataset;
        wx.navigateTo({ url: `/pages/${route}` })
    },
    // 赛事管理
    toScore: async function (e) {
        const that = this;
        const { item } = e.currentTarget.dataset;
        const arr = await app.$get(`/newCourt/api/race/${item._id}`);
        if (arr.errcode == '0') { that.setData({ form: arr.data }) }
        that.setData({ dialog: { title: '赛事管理', show: true, type: '1' } });
    },
    // 选择比赛状态
    statusChange: function (e) {
        const that = this;
        let data = that.data.statusList[e.detail.value];
        if (data) { that.setData({ 'form.status': data.value }) }
    },
    // 提交保存
    onSubmit: async function (e) {
        const that = this;
        const params = e.detail.value;
        const arr = await app.$post(`/newCourt/api/race/${params._id}`, params);
        if (arr.errcode == '0') {
            wx.showToast({ title: `上分成功`, icon: 'error', duration: 2000 })
            that.toClose()
        } else {
            wx.showToast({ title: `${arr.errmsg}`, icon: 'error', duration: 2000 })
        }
    },
    // 关闭弹框
    toClose: function () {
        const that = this;
        that.setData({ form: {} })
        that.setData({ dialog: { title: '赛事管理', show: false, type: '1' } })
        that.watchLogin();
    },
    // 信息维护
    toEdit: function (e) {
        const { item } = e.currentTarget.dataset;
        wx.navigateTo({ url: `/pages/race/add?id=${item._id}` })
    },
    // 删除
    toDel: function (e) {
        const that = this;
        const { item } = e.currentTarget.dataset;
        wx.showModal({
            title: '提示',
            content: '是否确认删除该条数据?',
            async success(res) {
                if (res.confirm) {
                    const arr = await app.$delete(`/newCourt/api/race/${item._id}`);
                    if (arr.errcode == '0') {
                        wx.showToast({ title: `删除信息成功`, icon: 'success', duration: 2000 })
                        that.watchLogin()
                    } else {
                        wx.showToast({ title: `${arr.errmsg}`, icon: 'error', duration: 2000 })
                    }
                }
            }
        })
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {


    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {
        const that = this;
        that.watchLogin()
    },
    watchLogin: function () {
        const that = this;
        const searchInfo = that.data.searchInfo;
        wx.getStorage({
            key: 'user',
            success: async (res) => {
                let arr;
                let info = { skip: 0, limit: 1000 };
                // if (searchInfo && searchInfo.name) info.name = searchInfo.name;
                arr = await app.$get(`/newCourt/api/race`, { ...info });
                if (arr.errcode == '0') { that.setData({ raceList: arr.data }) }
                else { wx.showToast({ title: `${res.errMsg}`, icon: 'fail', duration: 2000 }); }


            },
            fail: async (res) => {
                wx.redirectTo({ url: '/pages/index/index' });
            },
        });
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})